i would install cron if its not installed, then add a file under
/etc/cron.d/someNiceToRememberName
and with an editor write the following in it:
@reboot root /bin/bash -x /usr/local/bin/ocamlfuseStartup.sh >> /tmp/output 2>&1 ; echo returncode=$? >> /tmp/output
where root is the user it should run with and the redirection (>> /tmp/output 2>&1) is for seeing what is wrong, and echo returncode= prints the exit error indicator.
you might be able to do this with systemd too, but it often messes things up and i like i.e. clean log outputs.
for testing you can add a line that would start it without a reboot.
22 * * * * root /path/to/your/command parameters >> /tmp/output 2>&1
where the 22 is the next minute it should run. with this cronjob it would be run at every x:22 after each hour 09:22 pm 10:22 pm aso. i do this sometimes for testing
as systemd starts cron with a broken environment too, it might as well not work using cron, but then you know its the broken environment systemd starts it with. if thats your problem, you might want to add: PATH=$PATH:/usr/sbin:/usr/local/sbin
somewhere at the top of the shellscript depending on what is missing, which by itself would be the directories the commands executed are in. in terminal use :
$ which sed
/sbin/sed
for example to find where the “sed” binary is located (if the script cannot find it) you could change every occurance of “sed” in the script with the full path to it, or add the directory using the PATH variable as a colon separated list of directories to search commands in (where order matters)
to maybe more easy see what is missing i added the -x as a parameter to bash which makes it print out a line for every command it executes to sdterr so you can see what the last commands were. you can try it in the terminal (if your terminal is bash or compatible
$ set -x
$ echo foo
+ echo foo
foo
$
i’ld guess systemd starts the shellscript with a broken environment and thats maybe why it doesnt work, maybe try adding this to the script too:
echo PATH: $PATH
somewhere at the top of the script and use the redirection i showed for the cron job. run it once in your terminal and compare the output with what it prints during automated script run.
good luck.
transition to linux. One of the first things I have hit a wall on is getting a file to execute on boot using systemd.
I am trying to use this package to be
that bash thing is the interpreter. the script ocamlFuseStartup.sh is written as bash (possibly the same as your terminal) if that script has a “shebang” (#!/bin/bash) as the very first line AND the file has the execute permission set (chmod +x /path/to/file), then you dont need /bin/bash at the beginning to start it.
not sure at what level you are, here are some hints:
take your time to understand what the things do. shells like bash are very powerful and accidentially typing simething wrong could cause data loss or similar. but as you said, take care that you undestand what things are for and how they work.
most tools like sed or bash have a manpage that helps. bash has a huge one as it is very powerull (want to “program” like in C with pointers to variables, bash can do so using eval, which is evil, it really has downsides when doing too much in bash), but anyway learn the tools you use as you try them.
you can leave the manpage with pressing “q”. pressing “h” shows how to navigate man pages.
the exit code of your script could come from bash itself or from the last command executed, it depends a bit. lets say bash stumbles over invalid syntax in the script while running the code or over a redirection (‘<’ ‘>’) that points to an empty variable or nonexisting directory, then its bash who exits with its error. so an empty variable could cause such an error. but it usually exits with the exit code of the last run command (see bash “set -e” option which lets bash exit on the first failed command which together with the “-x” switch is very handy, but dont confuse it with other “-e” things in bash’s huge manpage)
try in your console:
$ ( exit 34 ) $ echo $? 34 $ /bin/false $ echo $? 1 $ ( set -e ; /bin/false ; echo bar ) $ echo $? 1 $ ( /bin/false ; echo foo ) foo $ echo $? 0
using () in a terminal opens a subshell so that what you do there (set -e, setting variables etc) does not affect your current shells environment (unless you change files on disk or such) in the last case the exit code was from the “echo foo” command which succeded and returned 0 while the exit code of /bin/false was ignored (other than in that ‘set -e’ example)
i use exit codes a lot in bash scripts to control script flow also together with functions.
some programs have a bit mask of what went wrong (‘man fsck’ explains that they use a bitwise OR to determine the resulting exit code of the program to include multiple possible errors at once) so when dealing with an exit code other than 0 you likely first want to know which program caused it (maybe using the “-x” switch i.e.) and then consult man page or online help what it means.
as ocamlfuseStartup.sh is a shellscript you likely find what happens inside of it.
good luck